<template>
  <div class="w-fit flex items-center rounded-[8px] gap-4 p-4 bg-surface cardShadow">
    <form class="items-center gap-2" :class="size === 'compact' ? 'flex flex-col' : 'flex'" @submit="handleSubmit">
      <svn-pro-text-field
        v-model="url"
        variant="outlined"
        label="Enter URL"
        class="w-[210px]"
      />

      <div class="flex items-center justify-between" :class="size === 'compact' ? 'w-full' : 'w-fit'">
        <svn-pro-button
          text="Apply"
          variant="text"
          :disabled="!(/^(\S+):(\/\/)?\S+$/).test(url)"
          @click="handleSubmit"
        />
  
        <svn-pro-icon-button
          icon="custom:mingcute:delete-2-line"
          variant="text"
          color="error"
          :disabled="!url"
          @click="onClear"
        />
      </div>
    </form>
  </div>
</template>

<script setup>
import { ref, onMounted } from "vue";
import SvnProTextField from "../../input/SvnProTextField.vue";
import SvnProButton from "../../button/SvnProButton.vue";
import SvnProIconButton from "../../button/SvnProIconButton.vue";

onMounted(() => {
  url.value = props.initialUrl || '';
  openInNewTab.value = props.initialOpenInNewTab || true;
});

const props = defineProps({
  size: { type: String, default: null },
  initialUrl: { type: String, default: null },
  initialOpenInNewTab: { type: Boolean, default: true },
});

const emits = defineEmits(['on-set-link', 'on-clear']);

const url = ref(null);
const openInNewTab = ref(null);

const isValidUrl = () => {
  return (/^(\S+):(\/\/)?\S+$/).test(url.value);
}

const handleSubmit = (e) => {
  if (e) {
    e.preventDefault();
  }
  if (isValidUrl) {
    emits('on-set-link', { url: url.value, openInNewTab: openInNewTab.value ? '_blank' : '' });
  }
}

const onClear = () => {
  emits('on-clear');
}
</script>

<style lang="scss">
.cardShadow {
  box-shadow: 0px 8px 10px 0px rgba(0, 0, 0, 0.14), 0px 3px 14px 0px rgba(0, 0, 0, 0.12), 0px 5px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>